#if !defined( __MP3TAGZ_H__ )
#define __MP3TAGZ_H__

#include <windows.h>

#define TAG_SIZE 3
#define TITLE_SIZE 30
#define ARTIST_SIZE 30
#define ALBUM_SIZE 30
#define YEAR_SIZE 4
#define COMMENT_SIZE 30
#define STYLE_SIZE 1

#pragma pack( push, 1 )

struct tMP3tag
{
    TCHAR tag[TAG_SIZE];
    TCHAR title[TITLE_SIZE];
    TCHAR artist[ARTIST_SIZE];
    TCHAR album[ALBUM_SIZE];
    TCHAR year[YEAR_SIZE];
    TCHAR comment[COMMENT_SIZE];
    BYTE style;
};

#pragma pack( pop )

struct tMP3tagZ
{
    TCHAR title[TITLE_SIZE + sizeof( '\0' )];
    TCHAR artist[ARTIST_SIZE + sizeof( '\0' )];
    TCHAR album[ALBUM_SIZE + sizeof( '\0' )];
    TCHAR year[YEAR_SIZE + sizeof( '\0' )];
    TCHAR comment[COMMENT_SIZE + sizeof( '\0' )];
    BYTE style;
    BOOL exist;
    WIN32_FIND_DATA findData;
};


tMP3tag *ZTAGtoTAG( tMP3tag *dest, const tMP3tagZ *src );
tMP3tagZ *TAGtoZTAG( tMP3tagZ *dest, const tMP3tag *src );
tMP3tagZ *TrimZTAG( tMP3tagZ *lpTagZ );
BOOL ReadMP3Tag( LPCTSTR MP3name, tMP3tag *tag );
BOOL WriteMP3Tag( LPCTSTR MP3name, const tMP3tag *tag );
BOOL DeleteMP3Tag( LPCTSTR MP3name );
BOOL MP3tagZ( const tMP3tagZ *tagZ );
BOOL MP3tag( const tMP3tag *tag );
tMP3tag *CharToOemTag( tMP3tag *tag );
tMP3tag *OemToCharTag( tMP3tag *tag );
BOOL ReadMP3TagZ( LPCTSTR MP3name, tMP3tagZ *lpTagZ );
BOOL WriteMP3TagZ( tMP3tagZ *lpTagZ );
tMP3tagZ *ZeroTagZ( tMP3tagZ *lpTagZ );

#endif
