#include <windows.h>
#include <plugin.hpp>
#include <mp3brws.h>
#include <mp3edit.h>

BOOL BrowseMp3( PluginStartupInfo *lpSI )
{
     PanelInfo panelInfo;
     BOOL Selected = FALSE;
     MP3_EDIT_RESULT Mp3EditResult;

     if ( !lpSI -> Control(
          INVALID_HANDLE_VALUE,
          FCTL_GETPANELINFO,
          &panelInfo ) )
     {
          return FALSE;
     }
     if ( ( panelInfo. PanelType != PTYPE_FILEPANEL ) ||
          ( !panelInfo. ItemsNumber ) )
     {
          return FALSE;
     }
     for ( int idx = 0, stop = panelInfo. ItemsNumber; idx < stop; idx++ )
     {
          if ( !( panelInfo. PanelItems[idx]. Flags & PPIF_SELECTED ) )
          {
               continue;
          }
          Selected = TRUE;
          Mp3EditResult = Mp3Edit(
               panelInfo. PanelItems[idx]. FindData. cFileName,
               lpSI
          );
          if ( Mp3EditResult == Ok )
          {
               panelInfo. PanelItems[idx]. Flags &= ~PPIF_SELECTED;
          }
          else if ( Mp3EditResult == Skip )
          {
               continue;
          }
          else
          {
               break;
          }
          if ( !lpSI -> Control(
                    INVALID_HANDLE_VALUE,
                    FCTL_SETSELECTION,
                    &panelInfo ) ||
               !lpSI -> Control(
                    INVALID_HANDLE_VALUE,
                    FCTL_REDRAWPANEL,
                    NULL ) ||
               !lpSI -> Control(
                    INVALID_HANDLE_VALUE,
                    FCTL_GETPANELINFO,
                    &panelInfo ) )
          {
               return FALSE;
          }
     }
     if ( !Selected )
     {
          Mp3Edit(
               panelInfo. PanelItems[panelInfo. CurrentItem]. FindData. cFileName,
               lpSI
          );
     }

     return TRUE;
}

