#include <windows.h>
#include <plugin.hpp>
#include <mp3msg.h>
#include <mp3misc.h>
#include <mp3edit.h>
#include <mp3desc.h>
#include <mp3tag.h>
#include <mp3reg.h>
#include <cfg.h>
#include <mp3tgfn.h>
#include <string.h>

PluginStartupInfo Info;
TCHAR PluginRootKey[REGKEYLEN];
TCHAR FarRootKey[REGKEYLEN];
TCHAR MP3StylesSubKey[] = "Plugins\\"MP3TAGSUBKEY"\\Styles";
TCHAR MP3OptionsSubKey[] = "Plugins\\"MP3TAGSUBKEY"\\Options";
TCHAR MP3Flags[] = "Flags";
TCHAR FarSavedDialogHistorySubKey[] = "SavedDialogHistory\\"MP3STYLEEDITHIST;
TCHAR StyleEditHistory[] = MP3STYLEEDITHIST;
DWORD dwFlags = 0;

BOOL LibMain( HANDLE, DWORD, LPVOID )
{
     return TRUE;
}

DWORD GetPluginFlags()
{
     return dwFlags;
}

extern "C" void WINAPI SetStartupInfo( PluginStartupInfo *Info )
{
     ::Info=*Info;
     strcpy( PluginRootKey, Info -> RootKey );
     GetFarRootKey( FarRootKey, Info -> RootKey );
}

extern "C" HANDLE WINAPI OpenPlugin( int /*OpenFrom*/, int Item )
{
     RegQueryOptions(
          FarRootKey,
          MP3OptionsSubKey,
          MP3Flags,
          &dwFlags
     );

     if ( Item == 0 )
     {
          RegCopyStylesToEditHistory(
               FarRootKey,
               MP3StylesSubKey,
               FarSavedDialogHistorySubKey
          );
          EditMP3();
     }
     else if ( Item == 1 )
     {
          DescMP3();
     }
     else
     {
          MP3TagToFromFilename();
     }

     return( INVALID_HANDLE_VALUE );
}

extern "C" void WINAPI GetPluginInfo( PluginInfo *lpPluginInfo )
{
     static char* PluginMenuStrings[3];
     static char* PluginConfigStrings[1];

     lpPluginInfo -> StructSize = sizeof( *lpPluginInfo );

     PluginMenuStrings[0] = ::Info. GetMsg( ::Info. ModuleNumber, MPluginMenuBrowse );
     PluginMenuStrings[1] = ::Info. GetMsg( ::Info. ModuleNumber, MPluginMenuDescript );
     PluginMenuStrings[2] = ::Info. GetMsg( ::Info. ModuleNumber, MPluginMenuFilename );

     lpPluginInfo -> PluginMenuStrings = PluginMenuStrings;
     lpPluginInfo -> PluginMenuStringsNumber = sizeof( PluginMenuStrings ) / sizeof( PluginMenuStrings[0] );

     PluginConfigStrings[0] = ::Info. GetMsg( ::Info. ModuleNumber, MPluginConfig );
     lpPluginInfo -> PluginConfigStrings = PluginConfigStrings;
     lpPluginInfo -> PluginConfigStringsNumber = sizeof( PluginConfigStrings ) / sizeof( PluginConfigStrings[0] );
}

extern "C" int WINAPI Configure( int ItemNumber )
{
     return Cfg( ItemNumber );
}

PluginStartupInfo* GetPSI()
{
     return &Info;
}

