#****************************************************************************
#
#  Project:     SAB
#  Description:
#
#****************************************************************************

#****************************************************************************
#    Project
#****************************************************************************

PrjName         = main
OS              = nt
#DEBUG_INFO      = Yes
#OPTIMIZATION    = Yes

#****************************************************************************
#    Modules names definition
#****************************************************************************

ExeName         = $(PrjName)                    # Project .exe filename

#****************************************************************************
#    Compilers root directories
#****************************************************************************

WATCOM_Dir      = $(%WATCOM)

#****************************************************************************
#    Default directories structure. Tools location definition.
#****************************************************************************

WC_Cpp          = $(WATCOM_Dir)\BINNT\wpp386
WLink           = $(WATCOM_Dir)\BINNT\wlink
WLib            = $(WATCOM_Dir)\BINNT\wlib
!loaddll wpp386 wppd386

#****************************************************************************
#    Options files
#****************************************************************************

WC_Cfg          = $(ExeName).ini               # Watcom compiler
WL_Cfg          = $(ExeName).lnk               # Watcom linker

#WC_Cpp_Opt      = -zq -bd -bt=$(OS) /er /s /zp1 /wx /zq /zkl /fp5
WC_Cpp_Opt      += /fo=$(OBJ)\ /i=$(WATCOM_Dir)\h;$(WATCOM_Dir)\h\nt;$(INC); /fhq=$(PCH)\$(ExeName).pch
WC_Cpp_Opt      += -dNT -dCONSOLE

!ifeq DEBUG_INFO Yes
WC_Cpp_Opt      += -d3 -hw
!else
!ifeq OPTIMIZATION Yes
WC_Cpp_Opt      += -oa -ob -oe -oh -oi+ -ok -ol+ -on -oo -or -ot -oz
!endif
!endif

#****************************************************************************
#    Watcom library utility options
#****************************************************************************

WLib_Opt        = -c -n -b

#****************************************************************************
#    Object files to include in project
#****************************************************************************

ObjLst          = main.obj templtok.obj strtok.obj cvtfname.obj

#****************************************************************************
#    Project target
#****************************************************************************

all : makedirs $(EXE)\$(ExeName).exe

$(EXE)\$(ExeName).exe : $(WL_Cfg) $(ObjLst)
     @echo **** Building "$^&" project ****
     @$(WLink) @$(WL_Cfg)

#****************************************************************************
#    Options files building
#****************************************************************************

$(WL_Cfg) : $(__MAKEFILES__)
     @echo **** Creating linker configuration file $^. ****
     @%create $^.
     @%append $^. SYSTEM $(OS)
     @%append $^. NAME $(EXE)\$(ExeName)
!ifeq DEBUG_INFO Yes
     @%append $^. DEBUG Watcom
!endif
     @%append $^. OPTION MAP=$(LNK)\$(PrjName),CACHE,ARTIFICIAL
     @for %ObjName in ($(ObjLst)) do @%append $^. FILE $(OBJ)\%ObjName
     @for %LibName in ($(LibLst)) do @%append $^. OPTLIB $(LIB)\%LibName

$(WC_Cfg) : $(__MAKEFILES__)
     @echo **** Creating compiler configuration file $^. ****
     @%create $^.
     @%append $^. $(WC_Cpp_Opt)
     @for %MacroName in ($(MACRO_LIST)) do @%append $^. /d%MacroName

$(ObjLst) : $(WC_Cfg) .autodepend

#****************************************************************************
#    Implict rules
#****************************************************************************

.c.obj :
     @echo **** Compiling source $[. file ****
     @$(WC_Cpp) $[@ @$(WC_Cfg)

.cpp.obj :
     @echo **** Compiling source $[. file ****
     @$(WC_Cpp) $[@ @$(WC_Cfg)

#****************************************************************************
#    Path to files with different extentions
#****************************************************************************

makedirs: .symbolic

     @if not exist $EXE @md $EXE
     @if not exist $DLL @md $DLL
     @if not exist $OBJ @md $OBJ
     @if not exist $LIB @md $LIB
     @if not exist $INC @md $INC
     @if not exist $SRC @md $SRC
     @if not exist $DOC @md $DOC
     @if not exist $ASM @md $ASM
     @if not exist $ARC @md $ARC
     @if not exist $ERR @md $ERR
     @if not exist $LNK @md $LNK
     @if not exist $PCH @md $PCH

#=== End ====================================================================
